Goodpoints <- function (target,delaysNnodes,lonlatNnodes)
{
# This function seeks the "good points" among the crossing points found before. These good points represent the intersection region of all circles.
# Good points are any points that are located in all circles. These good points allow us to find the area where we expect that the target host is located. 
# These good points will be the vertices of the polygon. Note that the polygon is the approximation of this intersection region. The longitude
# and the latitude of good points are saved in a file whose name is the IP address of the given target host and the file is located in the folder
# "Bonpoint". It should be noted that if we have two good points, the intersection region will be the circle whose diameter is the geographic
# distance of these two points.
	
	nlandmark<-length(delaysNnodes)
	nomfic<-paste("Crossingpoint/crossingpoint-",target,sep="")
	ficrslt<-paste("Bonpoint/zonecross-",target,sep="")
	if(file.exists(ficrslt)){file.remove(ficrslt)}
	if(file.exists(nomfic)){
		npoints<-(1:nlandmark)
		# seeks the smallest radius. 
		mindelaysNnodes<-min(delaysNnodes)
		pos<-which.min(delaysNnodes)
		ptcrossing<-matrix(as.vector(as.matrix(read.table(nomfic))),nc=2)
		long<-length(ptcrossing[,1])
		# "bondist" expresses the least distance between any landmark toward a target.
		bondist<-delaysNnodes[pos]
		test<-0
		for(j in 1:long){
			compteur<-0
			D1<-calculdist(deg2rad(lonlatNnodes[pos,1]),deg2rad(lonlatNnodes[pos,2]),deg2rad(ptcrossing[j,1]),deg2rad(ptcrossing[j,2]))
#  
			if(D1<=bondist){
# seek if the giveb point is inside all circles
				for(z in npoints){
					D2<-calculdist(deg2rad(lonlatNnodes[z,1]),deg2rad(lonlatNnodes[z,2]),deg2rad(ptcrossing[j,1]),deg2rad(ptcrossing[j,2]))
					if(D2<=delaysNnodes[z]){
						compteur<-compteur+1
					}
				}
			}
#               cat("compteur =",compteur,"\n")
			if(compteur==length(npoints)) {
				write(ptcrossing[j,],ficrslt,append=TRUE)
				test<-test+1
			}
		}
#       cat("test=",test,"\n")
		if(test==0) {write(" ",ficrslt)}
# 	else {cat("bon node",target,"\n")}
	}
}
