Newcrosscircle <- function(target,delaysNnodes,lonlatNnodes)
{
#########################################################################################################################################
# The function Newcrosscircle seeks the crossing points between the circles that have as center the geographic position of the landmarks
# and as radius the geographic distance from each landmark toward a given target host. For each landmark, it draws the circle whose 
# radius is the geographic distance between this landmark and the target host, and centered at the position of the landmark. 
# this function returns a variable. If the value of this variable is equal to zero we have no crossing points so we can not localize this target host. 
# If its value is different to zero, the longitude and the latitude of each crossing point are saved in a file whose name is the IP address of the target
# host and located in the folder "Crossingpoint"
##########################################################################################################################################

	
# delaysNnodes represents the distance, in km,  between a given landmark and the target. It can be seen as the radius of the circle
# where the center is the geographic position (longitude,latitude), in degrees,  of the landmarks.
# lonlat contains the longitude et latitude of our set of landmarks. It will be use as the center of our circle.
	nlandmarks<-length(delaysNnodes)
# the function plotcircle() gives the coordinates of points which form a given circle
	veclines<-plotcircle(lonlatNnodes[1,1],lonlatNnodes[1,2],delaysNnodes[1])
	for(j in 2:nlandmarks){
        matline<-plotcircle(lonlatNnodes[j,1],lonlatNnodes[j,2],delaysNnodes[j])
        veclines<-cbind(veclines,matline)
	}
	L<-ncol(veclines)
	lineA<-matrix(0,nr=101,nc=2)
	lineB<-matrix(0,nr=101,nc=2)
# file that receives the crossing points. 
	nomfic<-paste("Crossingpoint/crossingpoint-",target,sep="")
	if(file.exists(nomfic)){file.remove(nomfic)}
	kl<-0
	indice<-1
# "bon" expresses if we have or not crossing points.
	bon<-0
	while(indice<=L)
	{
#cat("indice=",indice,"\n")
		kl<-kl+1
#cat("kl= ",kl,"\n") 
		h<-kl
		compteur<-indice
		compteur<-compteur+2
        while( compteur<= L &&  h < nlandmarks){
# radius of the first circle
			R1<-delaysNnodes[kl]
# coordinates of the first circle
			lon1<-lonlatNnodes[kl,1]
			lat1<-lonlatNnodes[kl,2]
#           cat("cercle1 ",lon1,lat1,R1,"\n")
# coordinates of the second circle 
			h<-h+1
			lon2<-lonlatNnodes[h,1]
			lat2<-lonlatNnodes[h,2]
# radius of the second circle
			R2<-delaysNnodes[h]
#       cat("cercle2 ",lon2,lat2,R2,"\n")
# points that form the first circle 
			lineA<-veclines[,indice:(indice+1)]
#       points(lineA,pch=22)
# points that form the second circle
			lineB<-veclines[,compteur:(compteur+1)]
#       points(lineB,pch=22)
			compteur<-compteur+2
# seek if this two circles cross or not
			if(cross(lon1,lat1,R1,lon2,lat2,R2)==1){
# find segment's first circle that cross the second circle 
				ptsegments1<-findsegments(lineA,R2,lon2,lat2)
#                       cat("ptsegments1=\n",t(ptsegments1),"\n")
#                       cat("nrow ptsegments1=",nrow(ptsegments1),"indice=",indice,"\n")
# find segment's second circle that cross first circle
#                       lines(lineB,col="green")
#                       cat("lon2=",lon2,"lat2=",lat2,"\n")
				ptsegments2<-findsegments(lineB,R1,lon1,lat1)
#                       cat("ptsegments2=\n",t(ptsegments2),"\n")
#                       cat("nrow ptsegments2=",nrow(ptsegments2),"compteur=",compteur,"\n")
				for(comp in 1:nrow(ptsegments1)){
					if(ptsegments1[comp,1]!=0){
						eq1<-eqdroite(ptsegments1[comp,1],ptsegments1[comp,2],ptsegments1[comp,3],ptsegments1[comp,4])
						for(ind in 1:nrow(ptsegments2)){
							if(ptsegments2[ind,1]!=0){
								eq2<-eqdroite(ptsegments2[ind,1],ptsegments2[ind,2],ptsegments2[ind,3],ptsegments2[ind,4])
								ptcross<-pointinter(eq1,eq2,ptsegments1[comp,1],ptsegments1[comp,3],ptsegments2[ind,1],ptsegments2[ind,3])
								if(is.numeric(ptcross)){
									D1<-calculdist(deg2rad(ptcross[1]),deg2rad(ptcross[2]),deg2rad(lon1),deg2rad(lat1))
									D2<-calculdist(deg2rad(ptcross[1]),deg2rad(ptcross[2]),deg2rad(lon2),deg2rad(lat2))
									if(D1<=R1 & D2<=R2){
										if((ptcross[1]>=-180 & ptcross[1]<=180)&(ptcross[2]>=-90 & ptcross[2]<=90)){
											write(ptcross,nomfic,append=TRUE)
											bon<-bon+1
#       cat("circle",indice," cross cercle",h,ptcross,"\n")
										}
# points(ptcross[1],ptcross[2],pch=20,col="red")
									}
								}
							}
						}
					}
				}
			}
        }
		indice<-indice+2
	}
	bon
}

