RunangleV2 <- function (target,delaysNnodes,lonlatNnodes,rtt)
{
	# This function provide the localisation of a target without plotting the points in a figure
	# "delaysNnodes" contains the geographical distance constraint between landmarks and target hosts
	# "lonlatNnodes" contains the position of all succesfull  landmarks
	# "target" the names of target hosts
	library(maps)
	nblandmark<-length(delaysNnodes)
	
	# rtt contains the min RTT between target host and landmarks
	rttNnodes<-rtt[goodlandRTT]
	posminrtt<-which.min(rttNnodes)
	figure<-paste("Figure-R/location_estimate_of_",target,".png",sep="")
	# on sort le resultat en format png , on cree le fichier .png
	#bitmap(figure,height=9, width=7,res=72,pointsize=12)
	# boolpolygone est une variable pour tester si on a un polygone ou pas
	boolpolygone<-0
	mindelaysNnodes<-min(delaysNnodes)
	pos<-which.min(delaysNnodes)
	ficrslt<-paste("Bonpoint/zonecross-",target,sep="")
	# we test if the file zonecross exits which expressed the targeted host is localizable
	if(file.exists(ficrslt)){
		# we test if we have no crossing point
		if(length(count.fields(ficrslt))==0){
				# the location of target host is assimilated to the closest landmark
				#  points(lonlatNnodes[pos,1],lonlatNnodes[pos,2],pch=4,col="red",cex=0.5)
				# we choose the position of target host the position of landmark which has the least RTT
				# CONDITION A REVOIR
				#if(posminrtt != pos) pos<-posminrtt
				
				write(c(target,lonlatNnodes[pos,1],lonlatNnodes[pos,2]),nc=3,"Rslt_localisation/estimate-loc.dat",append=TRUE)
				LONGITUDE<-lonlatNnodes[pos,1]
				LATITUDE<-lonlatNnodes[pos,2]
				write(c(target,delaysNnodes[pos]),nc=2,"Rslt_localisation/rayon-centroid-v2.dat",append=TRUE)
				# calcul surface du cercle
				AIRE<-pi*(delaysNnodes[pos]^2)
				write(c(target,AIRE),nc=2,"Rslt_localisation/aire-polygone-v2.dat",append=TRUE)
				rayon<-delaysNnodes[pos]	
				boolpolygone<-2	
		}
		# we have crossing points
		else{
				#   points(matrix(as.vector(as.matrix(read.table(ficrslt))),nc=2),col="red",pch=20,cex=0.5)
				pointcross<-matrix(as.vector(as.matrix(read.table(ficrslt))),nc=2)
				long<-length(pointcross[,1])
				angles<-matrix(0,nr=long,nc=1)
				# coordonnee du point initial du polygone (x0,y0)
				# calcul de l'angle que fait (x0,y0) avec tous les autres points qui constituent la zone d'erreur
				posmin<-which.min(pointcross[,1])
				xzero<-pointcross[posmin,1]
				yzero<-pointcross[posmin,2]
				for(j in 1:long){
					angles[j]<-rad2deg(calculangle(xzero,yzero,pointcross[j,1],pointcross[j,2]))
				}
				# tri des angles de maniere croissante
				angles<-sort(angles)
				#ordonnancement des points du polygone
				# vecteur des points tries par ordre
				pointordonne<-matrix(0,nc=2,nr=long)
				if(length(angles)>=3){
					compteur<-1
					while(compteur<=long){
						for(k in 1:long){
							ang<-rad2deg(calculangle(xzero,yzero,pointcross[k,1],pointcross[k,2]))
							if(identical(ang,angles[compteur])==TRUE){
								pointordonne[compteur,1]<-pointcross[k,1]
								pointordonne[compteur,2]<-pointcross[k,2]
							}
						}
						compteur<-compteur+1
					}
					# calcul de l'aire et du centre du polygone(Cx,Cy) R=sqrt(Aire/pi)
					#	conversion des degres en km (lon,lat)---->(dlon*lon,dlat*lat)
					# dlon et dlat represente le coeff de conversion different pour chaque polygonne
					pointenKM<-degre2km(pointordonne)
					pointendegre<-pointordonne
					#calcul du centroid du polygone et du rayon du cercle inscrit a ce polygone
					# airepolygone est la fonction qui retourne le centre, le rayon et l'aire du polygone, et trace les sommets du polygone	
					CxCyRAIRE<-airepolygone(pointendegre,pointenKM)
					# regarder le cas ou notre plolygone est constitue de + de 3 points mais ayant des point identiques
					# d'ou en realite pas de polygone => AIRE == 0
					# on teste si la surface est differente de zero donc cas ou on a un polygone
					if(CxCyRAIRE[4]!=0 && CxCyRAIRE[4]!=1){
						#	on trace le centroid du polygone (estimation de localisation du point)
						#	points(CxCyRAIRE[1],CxCyRAIRE[2],pch=4,col="red",cex=0.5)
						write(c(target,formatC(CxCyRAIRE[1],digits=2,format="f"),formatC(CxCyRAIRE[2],digits=2,format="f")),nc=3,"Rslt_localisation/estimate-loc.dat",append=TRUE)
						LONGITUDE<-CxCyRAIRE[1]
						LATITUDE<-CxCyRAIRE[2] 
						write(c(target,CxCyRAIRE[3]),nc=2,"Rslt_localisation/rayon-centroid-v2.dat",append=TRUE)
						write(c(target,CxCyRAIRE[4]),nc=2,"Rslt_localisation/aire-polygone-v2.dat",append=TRUE)
						# on a un polygone on met la variable a 1
						boolpolygone<-1 
					}
					# cas ou le polygone n'est pas convexe on calcule le polygone avec R.
					else if(CxCyRAIRE[4]==1){
						# points(lonlatNnodes[pos,1],lonlatNnodes[pos,2],pch=4,col="red",cex=0.5)
						aire <- area.polygon(pointcross)
						rayon <- sqrt(aire/pi)
						LONGITUDE <- centroid.polygon(pointcross)[1]
						LATITUDE <- centroid.polygon(pointcross)[2]
						write(c(target,LONGITUDE,LATITUDE),nc=3,"Rslt_localisation/estimate-loc.dat",append=TRUE)
						write(c(target,rayon),nc=2,"Rslt_localisation/rayon-centroid-v2.dat",append=TRUE)
						write(c(target,aire),nc=2,"Rslt_localisation/aire-polygone-v2.dat",append=TRUE)
					}
					# si AIRE == 0 on a des points identiques dans notre matrice et en realite
					# on a que 2 points ou 1 point on cherche le barycentre
					else{
						for(zt in 2:long){
							D<-calculdist(deg2rad(pointcross[1,1]),deg2rad(pointcross[1,2]),deg2rad(pointcross[zt,1]),deg2rad(pointcross[zt,2]))
							if(D!=0){
								rayon<-D/2
								CxCyRAIRE[3]<-rayon
								CxCyRAIRE[4]<-pi*(rayon^2)
							}
						}
						lonbar<-0
						latbar<-0
						for(jk in 1:long){
							lonbar<-lonbar + pointcross[jk,1]
							latbar<-latbar + pointcross[jk,2]
						}
						lonbar<-lonbar/long
						latbar<-latbar/long
						CxCyRAIRE[1]<-lonbar
						CxCyRAIRE[2]<-latbar
						write(c(target,formatC(CxCyRAIRE[1],digits=2,format="f"),formatC(CxCyRAIRE[2],digits=2,format="f")),nc=3,"Rslt_localisation/estimate-loc.dat",append=TRUE)
						LONGITUDE<-CxCyRAIRE[1]
						LATITUDE<-CxCyRAIRE[2] 
						rayon<-CxCyRAIRE[3]
						boolpolygone<-2	
						write(c(target,CxCyRAIRE[3]),nc=2,"Rslt_localisation/rayon-centroid-v2.dat",append=TRUE)
						write(c(target,CxCyRAIRE[4]),nc=2,"Rslt_localisation/aire-polygone-v2.dat",append=TRUE)
					}
				}
				# cas ou on a moins de 3 crossing points   
				else{
					# calcul surface zone d'erreur
					#  on a deux points qui appartiennent a tous les cercles
					if(length(angles)==2){
						diametre<-calculdist(deg2rad(pointcross[1,1]),deg2rad(pointcross[1,2]),deg2rad(pointcross[2,1]),deg2rad(pointcross[2,2]))
						rayon<-diametre/2
						A2<-pi*(rayon^2)
						write(c(target,A2),nc=2,"Rslt_localisation/aire-polygone-v2.dat",append=TRUE)
						write(c(target,rayon),nc=2,"Rslt_localisation/rayon-centroid-v2.dat",append=TRUE)
						lonbar<-0
						latbar<-0
						for(jl in 1:long){
							lonbar<-lonbar + pointcross[jl,1]
							latbar<-latbar + pointcross[jl,2]
						}
						lonbar<-lonbar/long
						latbar<-latbar/long
						# points(lonbar,latbar,pch=4,cex=0.5,col="red")
						write(c(target,formatC(lonbar,digits=2,format="f"),formatC(latbar,digits=2,format="f")),nc=3,"Rslt_localisation/estimate-loc.dat",append=TRUE)
						LONGITUDE<-lonbar
						LATITUDE<-latbar
						# cas ou on a un barycentre 	
						boolpolygone<-2 
					}
					else{
						#  on a un point qui appartient a tous les cercles
						rayon<-delaysNnodes[pos]
						write(c(target,rayon),nc=2,"Rslt_localisation/rayon-centroid-v2.dat",append=TRUE)
						A2<-pi*(rayon^2)
						write(c(target,A2),nc=2,"Rslt_localisation/aire-polygone-v2.dat",append=TRUE)
						write(c(target,lonlatNnodes[pos,1],lonlatNnodes[pos,2]),nc=3,"Rslt_localisation/estimate-loc.dat",append=TRUE)
						LONGITUDE<-lonlatNnodes[pos,1]
						LATITUDE<-lonlatNnodes[pos,2]
						boolpolygone<-2 
					}
				}
			}
	}
	# the target host is not localizable
	else{
		write(c(target,0),nc=2,"Rslt_localisation/rayon-centroid-v2.dat",append=TRUE)
		write(c(target,0),nc=2,"Rslt_localisation/aire-polygone-v2.dat",append=TRUE)
		write(c(target,0,0),nc=3,"Rslt_localisation/estimate-loc.dat",append=TRUE)
	}
}
